<?php
/*
 You may not change or alter any portion of this comment or credits of
 supporting developers from this source code or any supporting source code
 which is considered copyrighted (c) material of the original comment or credit
 authors.

 This program is distributed in the hope that it will be useful, but
 WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */
/**
 * Module: xForms
 *
 * @package   \XoopsModules\Xforms\include
 * @author    XOOPS Module Development Team
 * @copyright Copyright (c) 2001-2019 {@link https://xoops.org XOOPS Project}
 * @license   https://www.gnu.org/licenses/gpl-2.0.html GNU Public License
 * @since     1.30
 */
namespace XoopsModules\Xforms;

use XoopsModules\Xforms\Helper as xHelper;
use Xmf\Module\Helper\Session;

require dirname(__DIR__) . '/preloads/autoloader.php';
$helper = xHelper::getInstance();

//define ('_XFORMS_SHOW_TPL_NAME', 0);
define ('_XFORMS_SHOW_TPL_NAME', $helper->getConfig('displayTemplateName'));
define ('_XFORMS_ERR_ON_CAPTCHA', $helper->getConfig('returnModeOnCaptchaErr'));
  
define ('_XFORMS_DIRNAME', basename(dirname(__DIR__)));

define ('_XFORMS_EDITOR_MODE', 0);

define ('_XFORMS_CPTCHA', "xoopscaptcha"); // image
//define ('__XFORMS_DIRNAME', basename(dirname(__DIR__)));
define ('XFORMS_DEFAULT', 'default');

//define ('_XFORMS_CPTCHA', "xformscaptcha"); // text


// define ('_XFORMS_INACTIVE', 0);
// define ('_XFORMS_ACTIVE', 1);
// define ('_XFORMS_EXPIRED', 2);
/**********************************************
 *
 **********************************************/
function jecho($value, $exp='', $hr=false, $exitMsg=''){
//func_num_args

        echo "{$exp} = {$value}";
        $fl = (($hr) ? "<hr>" : "<br>");
        echo $fl;
        if ($exitMsg) exit($exitMsg);
}
/**********************************************
 *
 **********************************************/
function getHtml($exp){
//global $myts;
  $myts = \MyTextSanitizer::getInstance();
  //return  html_entity_decode($myts->displayTarea($exp));
  return  html_entity_decode($myts->displayTarea($exp));
}

/**********************************************
 *
 **********************************************/
function get_editor($caption, $name, $exp, $width='100%', $height = '260px'){
global $myts;
  $formHtmlConfigs = array('editor' => get_editor_name(),
                             'rows' => 8,
                             'cols' => 30,
                            'width' => $width,
                           'height' => $height,
                             'name' => $name,
                            'value' => $myts->htmlSpecialChars($exp)
  );
  $editor = new \XoopsFormEditor($caption, $name, $formHtmlConfigs);
  return $editor;
}

/**********************************************
 *
 **********************************************/
function get_editor_name($user = 'user'){ //user / admin / sys config
global $xoopsModuleConfig;
  //$sysHelper - > getConfig('general_editor')
  //get_editor_name()
  switch ($user){
  case 'user' :  $editor = $xoopsModuleConfig['editorAdmin']; break;
  case 'admin' : $editor = $xoopsModuleConfig['editorAdmin']; break;
  default :      $editor = $sysHelper->getConfig('general_editor'); break;
  }
  return $editor;

}

/**********************************************
 *
 **********************************************/
function format_chrono_temp($options){
$value    = intval($options[0]);
$nbDigits = intval($options[1]);
$prefix   = $options[3];
$suffix   = $options[4];
$step     = intval($options[2]);
$bold     = intval($options[5]);

//echo "<pre>" . print_r($options, true) . "</pre>";

$codesFormat = "dDjlNSwzWFmMntLoYyaABgGhHisu";

  $v = $value; // + $step
  $chrono = $prefix . str_pad($v , $nbDigits, "0", STR_PAD_LEFT) . $suffix;

  for($h=0; $h < strlen($codesFormat); $h++){
    $chrono = str_replace("{" . $codesFormat[$h] . "}" , date($codesFormat[$h]), $chrono);
  }

  if ($bold == 1){
    $chrono = "<B>{$chrono}</B>";
  }
  return $chrono;


}

/**********************************************
 *
 **********************************************/
function format_chrono($eleArray){
global $xoopsDB;
    $ele_id      = (int)$eleArray['ele_id'];
 //echo "eleArray<pre>" . print_r($eleArray, true) . "</pre>";
    //-----------------------------------------------
    $sql = "SELECT * FROM " . $xoopsDB->prefix("xforms_element")
          . " WHERE ele_id = {$ele_id}";
    $rst = $xoopsDB->query($sql);
    $tEle = $xoopsDB->Fetcharray($rst);

    $data = unserialize($tEle['ele_value']);
    $keys = array_keys($data);

    $chrono = format_chrono_temp(array_values($data));
    //------------------------------------------------------------------
    $data[$keys[0]] += $data[$keys[2]];
    $serialData = serialize($data);

    $sql = "UPDATE " . $xoopsDB->prefix("xforms_element")
          . " SET ele_value = '{$serialData}'"
          . " WHERE ele_id = {$ele_id}";
    $xoopsDB->query($sql);



// echo "avant : " . $tEle['ele_value'] . "<br>";
// echo "apres : " . $serialData . "<br>";
//
//  echo "{$sql}<br>";
//  echo "<pre>" . print_r($rst, true) . "</pre>";
//  echo "<pre>" . print_r($DataValue, true) . "</pre>";
//  exit;

//   $v = $value + $step;
//   $chrono = $prefix . str_pad($v , $nbDigits, "0", STR_PAD_LEFT) . $suffix;
  return $chrono;


}
/**********************************************
 *
 **********************************************/
function format_timestamp($options){
//$value    = intval(mktime()));
//     $ele_id      = (int)$eleArray['ele_id'];
//     $values = $options['ele_value'];
 //echo "eleArray<pre>" . print_r($eleArray, true) . "</pre>";
    //-----------------------------------------------
$tsFormat = $options[0];
$bold   = intval($options[1]);

//echo "<pre>" . print_r($options, true) . "</pre>";

  $timestamp = date($tsFormat);

  if ($bold == 1){
    $timestamp = "<B>{$timestamp}</B>";
  }
//  echo "===>timestamp = {$timestamp}<br>";
  return $timestamp;


}

/**********************************************
 *
 **********************************************/
function get_color_set($color_set=''){
global $xoopsModuleCongig, $helper;
  if ($color_set == '' || $color_set == 'defaut' )
      $color_set = XFORMS_DEFAULT;


  return (($color_set == '') ? XFORMS_DEFAULT : $color_set);
}
/**********************************************
 *
 **********************************************/
function get_css_path(){
global $helper, $xoopsModuleCongig;
$helper = xHelper::getHelper("xforms");

    $cssFld = $helper->getConfig('css_folder');
    //$cssFld = $xoopsModuleCongig['css_folder'];

    if ($cssFld == "" ){
      $dir = "modules/" . _XFORMS_DIRNAME . "/assets/css";
    }else{

      if ($cssFld[0] == '/') $cssFld = substr($cssFld, 1);
      if ($cssFld[strlen($cssFld)-1] == '/') $cssFld = substr($cssFld, -1);
      $dir = $cssFld;
    }
//echo "<hr>{$dir}<hr>";
    return $dir;
}
/**********************************************
 *
 **********************************************/
function get_css_color(){
global $helper;

    $filename = XOOPS_ROOT_PATH . "/" . get_css_path() . "/style-item-color.css";
    $content = file_get_contents ($filename);

//echo "<br>{$filename}<br>{$content}<br>";
    $tLines = explode("\n" , $content);
//echo "nbLines = " . count($tLines) . "<pre>" . print_r($tLines, true) . "</pre>";
//echo "nbLines = " . count($tLines) ;
//  echo "<pre>" . print_r($tLines, true) . "</pre>";

    $tColors = array(XFORMS_DEFAULT => XFORMS_DEFAULT);
    foreach($tLines as $line){
      if(strlen($line)>0 && $line[0] == "."){
        $t = explode("-", $line);
        $color = substr($t[0],1);
        if (!array_key_exists($color, $tColors)){
            $tColors[$color] = $color;
        }
      }
    }

    return $tColors;
}

/**********************************************
 *
 **********************************************/
function load_css($color="*"){
global $helper;


    if ($helper->getConfig('css_folder') =="" ){
      $dir = "browse.php?" . get_css_path();
    }else{
      $dir = get_css_path();
    }
    //$dir = "" . $fld;

    $GLOBALS['xoTheme']->addStylesheet($GLOBALS['xoops']->url($dir . "/style-item-design.css"));
    $GLOBALS['xoTheme']->addStylesheet($GLOBALS['xoops']->url($dir . "/style-item-color.css"));

// echo "<hr>===> CSS folder : " . $helper->getConfig('css_folder',"s")  . "<br>";
// echo "<hr>===> CSS folder : " . $dir  . "<hr>";

}
/**********************************************
 *
 **********************************************/
function get_class_tr(&$row){
  $row = ($row + 1) % 2;
  $ligne = ($row == 0) ? 'odd' : 'even';
  return $ligne;
}

/**********************************************
 *
 **********************************************/
function load_jquery(){
global $helper;
}